/*=========================================================================
 *
 *  Copyright RTK Consortium
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0.txt
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 *=========================================================================*/

#ifndef rtkDrawSheppLoganFilter_hxx
#define rtkDrawSheppLoganFilter_hxx

#include "rtkDrawSheppLoganFilter.h"
#include "rtkSheppLoganPhantom.h"

namespace rtk
{
template <class TInputImage, class TOutputImage>
DrawSheppLoganFilter<TInputImage, TOutputImage>
::DrawSheppLoganFilter()
{
  this->SetPhantomScale(ConvexShape::VectorType(128));
}

template <class TInputImage, class TOutputImage>
void
DrawSheppLoganFilter<TInputImage, TOutputImage>
::GenerateData()
{
  this->SetGeometricPhantom( SheppLoganPhantom::New().GetPointer() );
  this->SetConfigFile("");
  Superclass::GenerateData();
}
} // end namespace rtk

#endif
